void draw() {
  background(WHITE);
  noStroke();
  textFont(font);
  translate( -width/2, -height/2);

  //paint years
  for (int yr=0; yr<6; yr++) {
    pushMatrix();
    fill(BLACK);
    textAlign(RIGHT, CENTER);
    text(years[yr], width-(width/8)+gutter, height/2, yr*dot*dot);
    popMatrix();
  }

  //paint months
  for (int nms=0; nms<months.length; nms++) {
    pushMatrix();
    fill(BLACK);
    textAlign(RIGHT, CENTER);
    rotate(-HALF_PI);
    text(months[nms], -width/4, height/3 + gutter*2 + nms*dot*pad, -gutter*2);
    rotate(0);
    popMatrix();
  }

  //paint rank 1-10
  for (int rnk=0; rnk<10; rnk++) {
    pushMatrix();
    fill(BLACK);
    textAlign(RIGHT, CENTER);
    if (rnk==0) text("More Checkouts", width/4-gutter*2, height/3+gutter+gutter*rnk, 3*dot*dot);
    else if (rnk==9) text("Less Checkouts", width/4-gutter*2, height/3+gutter+gutter*rnk, 3*dot*dot);
    text("#" + (rnk+1), width/4-gutter, height/3+gutter+gutter*rnk, 0);
    popMatrix();
  }


  for (int yr=0; yr<6; yr++) {
    for (int mnth=0; mnth<12; mnth++) {
      for (int dc=0; dc<10; dc++) {

        //check if a category is turned on
        //also check which year is active
        if ( (instance[yr][mnth][dc].selected && activeYear==yr) || (activeYear==-1 && instance[yr][mnth][dc].selected) ) {
          int gg, so;
          
          //store a ranking order for YearX MonthY
          for (int q=0; q<nRow; q++) {
            unorg[q] = instance[yr][mnth][q];
          } 
          gg = findIndexDD(instance[yr][mnth][dc].nCouts, unorg);

          
          //get a color associated with the category
          switch( instance[yr][mnth][dc].cat ) {
          case 0: 
            fill( colorArray[0], 255-gg*12); 
            break; 
          case 1: 
            fill( colorArray[1], 255-gg*12); 
            break; 
          case 2: 
            fill( colorArray[2], 255-gg*12); 
            break; 
          case 3: 
            fill( colorArray[3], 255-gg*12); 
            break; 
          case 4: 
            fill( colorArray[4], 255-gg*12); 
            break; 
          case 5: 
            fill( colorArray[5], 255-gg*12); 
            break; 
          case 6: 
            fill( colorArray[6], 255-gg*12); 
            break; 
          case 7: 
            fill( colorArray[7], 255-gg*12); 
            break; 
          case 8: 
            fill( colorArray[8], 255-gg*12); 
            break; 
          case 9: 
            fill( colorArray[9], 255-gg*12); 
            break;
          }

          pushMatrix();
          translate(width/4, height/3); 
          translate( mnth *dot*pad, (10 - gg)*gutter, yr *dot*dot);

          //determine if uniform volumes
          if (singleSize) so = dot;
          else            so = instance[yr][mnth][dc].nCouts + 2;
          
         if(instance[yr][mnth][dc].nCouts >= 1) {
           sphere( so );
         } else {
           fill(GREY, 132);
           sphere(1); 
         }
         
         popMatrix();
        }//end if check
        
      } //end dcs loop
    } //end months loop
  } //end years loop


  //set up fixed hud
  cam.beginHUD();
  textFont(font);
  textAlign(LEFT, CENTER);
  fill(BLACK);
  
  //paint categories
  for (int z=0; z<10; z++) {
    text( "#" + (z+1)%10, gutter, gutter*z+gutter);

    //determine which category is active
    if (z==0 && dc1) { 
      fill(colorArray[z]); 
      ellipse(pad*5, gutter*z+gutter, pad, pad);
    }
    if (z==1 && dc2) { 
      fill(colorArray[z]); 
      ellipse(pad*5, gutter*z+gutter, pad, pad);
    }
    if (z==2 && dc3) { 
      fill(colorArray[z]); 
      ellipse(pad*5, gutter*z+gutter, pad, pad);
    }
    if (z==3 && dc4) { 
      fill(colorArray[z]); 
      ellipse(pad*5, gutter*z+gutter, pad, pad);
    }
    if (z==4 && dc5) { 
      fill(colorArray[z]); 
      ellipse(pad*5, gutter*z+gutter, pad, pad);
    }
    if (z==5 && dc6) { 
      fill(colorArray[z]); 
      ellipse(pad*5, gutter*z+gutter, pad, pad);
    }
    if (z==6 && dc7) { 
      fill(colorArray[z]); 
      ellipse(pad*5, gutter*z+gutter, pad, pad);
    }
    if (z==7 && dc8) { 
      fill(colorArray[z]); 
      ellipse(pad*5, gutter*z+gutter, pad, pad);
    }
    if (z==8 && dc9) { 
      fill(colorArray[z]); 
      ellipse(pad*5, gutter*z+gutter, pad, pad);
    }
    if (z==9 && dc0) { 
      fill(colorArray[z]); 
      ellipse(pad*5, gutter*z+gutter, pad, pad);
    }

    fill(BLACK);
    text( ddNames[z], gutter*3, gutter*z+gutter );
  }
  
  //title
  textFont(fontXL);
  fill(GREY);
  text("Checkout trends of", gutter, height - gutter*2);
  fill(BLACK);
  text("Modern Western philosophy (19th-century, 20th-century)", gutter, height - gutter);
  
    
  textFont(font);
  fill(BLACK);

  int tt;
  int x = width - gutter*5;
  int y= gutter;
  
  //each year
  for(tt=0; tt <numYears; tt++) {
     text( "'" +  pressYr[tt] + "'", x, tt*y+gutter );
     if(tt == activeYear) {
       fill(GREY);
       ellipse( x + gutter+pad, tt*y+gutter, pad, pad);
       fill(BLACK);
     }
     text( years[tt], x +gutter*2, tt*y+gutter);
  }
  
  //all years
  text("'" + pressYr[tt] + "'", x, tt*y+gutter);
  if(activeYear == -1) {
       fill(GREY);
       ellipse( x + gutter+pad, tt*y+gutter, pad, pad);
       fill(BLACK);
  }
  text("All Years", x+gutter*2, tt*y+gutter);
  
  //other options
  x = width - gutter*7;
  y = height - gutter*2;
  for(int oo=0; oo <pressOpt.length; oo++) {
     text( "'" +  pressOpt[oo] + "'", x, y+(oo*gutter) );
     if(oo == 0 && singleSize) {
       fill(GREY);
       ellipse( x + gutter+pad, y+(oo*gutter), pad, pad);
       fill(BLACK);
     }
     if(oo == 1 && nightMode) {
       fill(GREY);
       ellipse( x + gutter+pad, y+(oo*gutter), pad, pad);
       fill(BLACK);
     }
  }
  text( "Ignore Count", x+gutter*2, y );
  text( "Dim the Lights", x+gutter*2, y+gutter);

  cam.endHUD();
}

